SystemOrganization addCategory: #'Tric-P2P-MC'!
SystemOrganization addCategory: #'Tric-P2P-Chat'!

Model subclass: #TPCChat
	instanceVariableNames: 'user peerId endPoint logStream node logLock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tric-P2P-Chat'!

!TPCChat class methodsFor: 'user interface' stamp: 'CdG 2/23/2005 22:08'!
openWith: aString on: aUUID endPoint: aSmallInteger node: aTPCNode
	| model |
	model _ self new chatWith: aString on: aUUID endPoint: aSmallInteger node: aTPCNode.
	ToolBuilder open: model label: 'P2P Chat with ', aString.
	^model! !

!TPCChat methodsFor: 'user interface' stamp: 'CdG 2/23/2005 22:03'!
buildWith: builder
	| windowSpec widget |
	windowSpec _ builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: 'Peer2Peer Chat with ', user.
	windowSpec extent: 500@300.
	windowSpec children: OrderedCollection new.

	widget _ builder pluggableTextSpec new.
	widget
		model: self;
		getText: #logText;
		frame: (0@0 corner: 1.0@0.9).
	windowSpec children add: widget.	

	widget _ builder pluggableInputFieldSpec new.
	widget
		model: self;
		setText: #sendChatLine:;
		frame: (0@0.9 corner: 1.0@1.0).
	windowSpec children add: widget.
		


	^builder build: windowSpec! !

!TPCChat methodsFor: 'initialize-release' stamp: 'CdG 2/23/2005 22:08'!
chatWith: aString on: aUUID endPoint: aSmallInteger node: aTPCNode
	user _ aString.
	peerId _ aUUID.
	endPoint _ aSmallInteger.
	node _ aTPCNode! !

!TPCChat methodsFor: 'user interface' stamp: 'TJ 2/24/2005 12:00'!
logLine: aString
	self logLock critical:[
		logStream nextPutAll: aString; cr.
		self changed: #logText]! !

!TPCChat methodsFor: 'as yet unclassified' stamp: 'TJ 2/24/2005 12:07'!
logLock
	^ logLock ifNil: [logLock _ Semaphore forMutualExclusion]! !

!TPCChat methodsFor: 'user interface' stamp: 'CdG 2/23/2005 22:07'!
logText
	logStream ifNil: [logStream _ WriteStream on: (String new: 1000)].
	^logStream contents! !

!TPCChat methodsFor: 'accessing' stamp: 'CdG 3/4/2005 13:53'!
nodeId
	^peerId! !

!TPCChat methodsFor: 'user interface' stamp: 'CdG 2/23/2005 22:13'!
receivedChatData: aString
	self logLine: user, ': ', aString! !

!TPCChat methodsFor: 'user interface' stamp: 'CdG 2/23/2005 22:15'!
sendChatLine: aText
	self logLine: node localUser, ': ', aText asString.
	node sendChatLine: aText asString to: peerId onEndPoint: endPoint! !

!TPCChat methodsFor: 'accessing' stamp: 'CdG 2/24/2005 11:27'!
user
	^user! !

!TPCChat methodsFor: 'user interface' stamp: 'CdG 2/23/2005 22:16'!
windowIsClosing
	node endChat: self! !

Model subclass: #TPCNode
	instanceVariableNames: 'peer chatEndPoint localUser logText currentChats logLock logStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tric-P2P-Chat'!

!TPCNode class methodsFor: 'as yet unclassified' stamp: 'Test 2/22/2005 23:49'!
onPeer: anAWGPeer
	^self new onPeer: anAWGPeer! !

!TPCNode class methodsFor: 'user interface' stamp: 'CdG 3/4/2005 13:35'!
open
	| answer peer |
	peer := AWGSingletonNode default.
	answer := ToolBuilder open: self.
	answer model onPeer: peer.
	^answer! !

!TPCNode class methodsFor: 'accessing' stamp: 'CdG 2/22/2005 23:03'!
wellKnownEndPoint
	"the endpoint to send searches to"
	^16r80! !

!TPCNode methodsFor: 'api' stamp: 'CdG 2/23/2005 20:59'!
availableForChat
	localUser _ Utilities authorInitials.
	self changed: #localUser! !

!TPCNode methodsFor: 'user interface' stamp: 'CdG 2/23/2005 21:30'!
buildWith: builder
	| windowSpec widget |
	windowSpec _ builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: 'Peer2Peer Chat'.
	windowSpec extent: 500@300.
	windowSpec children: OrderedCollection new.

	widget _ builder pluggableCheckBoxSpec new.
	widget 
		model: self;
		action: #toggleAvailableButton;
		color: #getAvailableColor;
		label: #getAvailableLabel;
		help: 'This button selects whether you are available for chat';
		frame: (0@0 corner: 0.3@0.10).
	windowSpec children add: widget.

	widget _ builder pluggableInputFieldSpec new.
	widget
		model: self;
		setText: #requestChatWith:;
		frame: (0.3@0 corner: 1.0@0.10).
	windowSpec children add: widget.
		
	widget _ builder pluggableTextSpec new.
	widget
		model: self;
		getText: #logText;
		frame: (0@0.10 corner: 1.0@1.0).
	windowSpec children add: widget.

	^builder build: windowSpec! !

!TPCNode methodsFor: 'private' stamp: 'CdG 2/23/2005 21:49'!
currentChats
	^currentChats ifNil: [currentChats _ Dictionary new]! !

!TPCNode methodsFor: 'api' stamp: 'CdG 3/4/2005 13:54'!
endChat: aTPCChat 
	self currentChats removeKey: aTPCChat nodeId ifAbsent: nil.
	self logLine: 'Chat with ' , aTPCChat user , ' ended'! !

!TPCNode methodsFor: 'api' stamp: 'TJ 2/24/2005 12:01'!
findUser: aString
	| search assoc |
	search _ AWGFloodSearch new.
	search 
		query: aString;
		onReceivedDo: [:result :source | 
			assoc _ Object readFrom: result asString.
			self logLine: 'result received: ', assoc printString, ' from: ', source printString.
			self openChatWith: assoc key on: source endPoint: assoc value];
		startSearchThrough: peer endPoint: self class wellKnownEndPoint.
	
	! !

!TPCNode methodsFor: 'user interface' stamp: 'CdG 2/23/2005 20:53'!
getAvailableColor
	^self isAvailable
		ifTrue: [Color green]
		ifFalse: [Color red]! !

!TPCNode methodsFor: 'user interface' stamp: 'CdG 2/23/2005 20:55'!
getAvailableLabel
	^self isAvailable
		ifTrue: [localUser]
		ifFalse: ['Not Available']! !

!TPCNode methodsFor: 'api' stamp: 'CdG 2/23/2005 20:54'!
isAvailable
	^localUser notNil! !

!TPCNode methodsFor: 'accessing' stamp: 'CdG 2/23/2005 22:12'!
localUser
	^localUser ifNil: ['n/a']! !

!TPCNode methodsFor: 'private' stamp: 'TJ 2/24/2005 12:03'!
logLine: aString
	self logLock critical:[
		logStream nextPutAll: aString; cr.
		self changed: #logText]! !

!TPCNode methodsFor: 'as yet unclassified' stamp: 'TJ 2/24/2005 11:59'!
logLock
	^ logLock ifNil: [logLock _ Semaphore forMutualExclusion]! !

!TPCNode methodsFor: 'user interface' stamp: 'TJ 2/24/2005 12:04'!
logText
	logStream ifNil: [logStream _ WriteStream on: (String new: 1000)].
	^logStream contents! !

!TPCNode methodsFor: 'api' stamp: 'CdG 2/23/2005 20:59'!
notAvailableForChat
	localUser _ nil.
	self changed: #localUser! !

!TPCNode methodsFor: 'initialize-release' stamp: 'CdG 2/22/2005 22:32'!
onPeer: anAWGPeer 
	peer := anAWGPeer.
	self start! !

!TPCNode methodsFor: 'private' stamp: 'TJ 2/24/2005 12:02'!
openChatWith: aString on: aUUID endPoint: aSmallInteger
	| newChat |
	(self currentChats includesKey: aUUID) ifTrue: [
		^self logLine: ' - existing chat, nothing done'].
	newChat _ TPCChat openWith: aString on: aUUID endPoint: aSmallInteger node: self.
	self currentChats at: aUUID put: newChat.
	self logLine: ' - opened new chat window'.
	^newChat
	! !

!TPCNode methodsFor: 'api' stamp: 'TJ 2/24/2005 12:02'!
receivedChatData: data from: sourcePeerId
	| chat packet |
	packet _ TPCChatPacket fromByteArray: data.
	chat _ self currentChats at: sourcePeerId ifAbsent: nil.
	chat ifNil: [
		AbstractSound hangUpWarning: 2. "Too lazy to design a sound myself :)"
		(self confirm: 'Chat received from ', packet user, ' - accept?') ifFalse: [
			self sendChatLine: 'Sorry, ', localUser, ' does not want to talk with you' to: sourcePeerId onEndPoint: packet endPoint.
			^self logLine: packet user, ' said "', packet text asString, '" but local user refused'].
		chat _ self openChatWith: packet user on: sourcePeerId endPoint: packet endPoint].
	chat receivedChatData: packet text.! !

!TPCNode methodsFor: 'private' stamp: 'CdG 3/4/2005 13:54'!
receivedSearch: data from: sourcePeerId 
	| search query |
	search := AWGFloodSearch fromByteArray: data.
	(search wasSeenBy: peer nodeId) ifTrue: [^self].
	query := search query asString asLowercase.
	(localUser notNil and: [query = localUser asLowercase]) 
		ifTrue: 
			[search returnResult: (localUser -> chatEndPoint) storeString onPeer: peer].
	search routeThrough: peer endPoint: self class wellKnownEndPoint! !

!TPCNode methodsFor: 'user interface' stamp: 'TJ 2/24/2005 12:02'!
requestChatWith: aText
	| strValue |
	strValue _ aText asString.
	self logLine: 'Requesting chat with ', strValue, ', please hold...'.
	self findUser: strValue! !

!TPCNode methodsFor: 'api' stamp: 'CdG 3/4/2005 13:55'!
sendChatLine: aText to: aUUID onEndPoint: aSmallInteger 
	| packet |
	packet := TPCChatPacket 
				text: aText
				fromUser: localUser
				onEndPoint: chatEndPoint.
	peer 
		send: packet asByteArray
		toNodeId: aUUID
		onEndPoint: aSmallInteger
		reliable: true! !

!TPCNode methodsFor: 'initialize-release' stamp: 'CdG 3/4/2005 13:54'!
start
	chatEndPoint := peer 
				dispatchDynamicEndPointTo: [:data :sourcePeerId | self receivedChatData: data from: sourcePeerId].
	peer dispatchEndPoint: self class wellKnownEndPoint
		to: [:data :sourcePeerId | self receivedSearch: data from: sourcePeerId].
	self logLine: 'Peer2Peer Chat started on node ' , peer nodeId printString! !

!TPCNode methodsFor: 'initialize-release' stamp: 'CdG 2/22/2005 22:32'!
stop
	peer unRegisterEndPoint: chatEndPoint.
	peer unRegisterEndPoint: self class wellKnownEndPoint.! !

!TPCNode methodsFor: 'user interface' stamp: 'CdG 2/23/2005 21:04'!
toggleAvailableButton
	self isAvailable
		ifTrue: [self notAvailableForChat]
		ifFalse: [self availableForChat].
	self changed: #getAvailableLabel.
	self changed: #getAvailableColor.! !

!TPCNode methodsFor: 'user interface' stamp: 'CdG 2/23/2005 21:27'!
windowIsClosing
	self stop.! !

AWGService subclass: #TPMCService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tric-P2P-MC'!

!TPMCService commentStamp: 'CdG 3/4/2005 13:47' prior: 0!
An AWGService subclass so we can hook into peer startup.!

!TPMCService class methodsFor: 'private' stamp: 'CdG 3/4/2005 13:55'!
confirmAvailabilityOf: fileName to: source endPoint: replyPort throughLocalNode: node 
	"if we really have the file, tell the sender so"

	(MCCacheRepository default allFileNames includes: fileName) 
		ifTrue: 
			[node 
				send: self positivelyAvailableCookie
				toNodeId: source
				onEndPoint: replyPort
				reliable: true	"whatever..."]! !

!TPMCService class methodsFor: 'private' stamp: 'CdG 3/4/2005 13:35'!
getPresence
	^AWGSingletonNode default presence! !

!TPMCService class methodsFor: 'private' stamp: 'CdG 3/4/2005 13:47'!
nodeStarted: anAWGNode
	"we're only interested in attaching to the default peer"

	| set |
	anAWGNode = AWGSingletonNode default ifFalse: [^self].
	self setupSearchResponderOn: anAWGNode.
	set := anAWGNode presence setAt: self presenceSetName.
	set
		timeToLive: 24 hours;
		beforeExpiryTest: [:fileName | MCCacheRepository default allFileNames includes: fileName]! !

!TPMCService class methodsFor: 'as yet unclassified' stamp: 'CdG 3/4/2005 13:24'!
p2pAnnounce: aString 
	| presence |
	presence _ self getPresence.
	presence ifNotNil: [
		presence addPresenceOf: aString in: self presenceSetName]! !

!TPMCService class methodsFor: 'as yet unclassified' stamp: 'CdG 3/4/2005 11:59'!
positivelyAvailableCookie
	"magic cookie that a file is positively available"
	^'YES!!' asByteArray ! !

!TPMCService class methodsFor: 'as yet unclassified' stamp: 'CdG 3/4/2005 13:26'!
presenceSetName
	^'nl.tric.p2p.mc'! !

!TPMCService class methodsFor: 'private' stamp: 'CdG 3/4/2005 13:55'!
sendContentsOf: fileName to: source endPoint: replyPort throuhLocalNode: node 
	| answer |
	answer := ByteArray new.
	(MCCacheRepository default allFileNames includes: fileName) 
		ifTrue: 
			[MCCacheRepository default readStreamForFileNamed: fileName
				do: [:strm | answer := strm binary upToEnd]].
	node 
		logLine: 'TPMCRepository responding with data for ' , fileName , ' to ' 
				, source printString.
	^node 
		send: answer
		toNodeId: source
		onEndPoint: replyPort
		reliable: true! !

!TPMCService class methodsFor: 'private' stamp: 'CdG 3/4/2005 13:50'!
setupSearchResponderOn: node 
	"
		self setupSearchResponderOn: AWGSingletonNode default
	"

	| assoc fileName replyPort |
	node dispatchEndPoint: self wellKnownEndPoint
		to: 
			[:data :source | 
			"see instance side #retrieveFileNamed:from:"

			assoc := Association readFrom: data asString.
			fileName := assoc key.
			replyPort := assoc value.
			fileName first = $? 
				ifTrue: 
					[self 
						confirmAvailabilityOf: (fileName copyFrom: 2 to: fileName size)
						to: source
						endPoint: replyPort
						throughLocalNode: node]
				ifFalse: 
					[self 
						sendContentsOf: fileName
						to: source
						endPoint: replyPort
						throuhLocalNode: node]]! !

!TPMCService class methodsFor: 'as yet unclassified' stamp: 'CdG 3/4/2005 12:00'!
wellKnownEndPoint
	^16r81! !

MCFileBasedRepository subclass: #TPMCRepository
	instanceVariableNames: 'localNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tric-P2P-MC'!

!TPMCRepository commentStamp: '<historical>' prior: 0!
This repository uses the p2p network to access versions. It uses the cache as shadow storage (there's an override in MCCacheRepository to announce new stuff on the network).!

!TPMCRepository class methodsFor: 'as yet unclassified' stamp: 'CdG 2/27/2005 01:30'!
description
	^ 'Tric P2P'! !

!TPMCRepository class methodsFor: 'instance creation' stamp: 'CdG 3/4/2005 14:36'!
new
	"singleton pattern for very lazy developers ;)"
	^self someInstance ifNil: [^super new]! !

!TPMCRepository methodsFor: 'required' stamp: 'CdG 3/4/2005 14:37'!
allFileNames
	| presence | 
	presence := self localNode presence.
	presence ifNil: [^#()].
	^((presence setAt: TPMCService presenceSetName) objects 
		collect: [:each | each object]) asSet! !

!TPMCRepository methodsFor: 'required' stamp: 'CdG 2/27/2005 02:31'!
description
	^self class description! !

!TPMCRepository methodsFor: 'initialize-release' stamp: 'CdG 3/4/2005 13:45'!
initialize
	localNode := AWGSingletonNode default! !

!TPMCRepository methodsFor: 'required' stamp: 'CdG 3/4/2005 14:35'!
localNode
	"for now, we just talk to the singleton instance"
	^AWGSingletonNode default! !

!TPMCRepository methodsFor: 'required' stamp: 'CdG 3/4/2005 11:45'!
readStreamForFileNamed: aString do: aBlock
	"set off a search, wait for a result to come in. Lots of optimization room here"
	| found |
	(MCCacheRepository default allFileNames includes: aString) ifTrue: [
		^MCCacheRepository default readStreamForFileNamed: aString do: aBlock].

	Cursor wait showWhile: [
		found _ self retrieveFileNamed: aString].
	found ifTrue: [
		^MCCacheRepository default readStreamForFileNamed: aString do: aBlock].
	self error: 'sorry, couldn''t find anything on the p2p net'! !

!TPMCRepository methodsFor: 'required' stamp: 'CdG 3/4/2005 18:05'!
retrieveFileNamed: aString 
	| sleeper registeredPorts receivedData confirmationPort sendQueue senderProcess presence hits |
	sleeper := Semaphore new.
	receivedData := false.
	registeredPorts := Set new.
	sendQueue := SharedQueue new.
	"stage 1: setup response handling."
	confirmationPort := self localNode dispatchDynamicEndPointTo: 
					[:data :source | 
					"setup a handler for the actual data"

					| uploadPort |
					data = TPMCService positivelyAvailableCookie 
						ifTrue: 
							[uploadPort := self localNode dispatchDynamicEndPointTo: 
											[:data2 :source2 | 
											data2 size > 0 
												ifTrue: 
													[MCCacheRepository default writeStreamForFileNamed: aString
														do: [:strm | strm nextPutAll: data2].
													receivedData := true.
													sleeper signal	"definitely done"]].
							registeredPorts add: uploadPort.

							"queue the send"
							sendQueue nextPut: 
									[self localNode 
										send: (aString -> uploadPort) storeString
										toNodeId: source
										onEndPoint: self class wellKnownEndPoint
										reliable: false]]].
	registeredPorts add: confirmationPort.

	"stage 2: ask all known peers whether the have the file"
	presence := self localNode presence.
	hits := (presence setAt: TPMCService presenceSetName) objects 
				select: [:each | each object = aString].
	hits do: 
			[:each | 
			self localNode 
				send: (('?' , aString) -> confirmationPort) storeString asByteArray
				toNodeId: each origin
				onEndPoint: TPMCService wellKnownEndPoint
				reliable: false].

	"this process will send out a single request, wait 10 seconds for an answer, then send the next request, etcetera"
	senderProcess := 
			[sendQueue next value.
			(Delay forDuration: 10 seconds) wait] fork.
	sleeper waitTimeoutSeconds: 60.
	senderProcess terminate.
	registeredPorts do: [:each | self localNode unRegisterEndPoint: each].
	^receivedData! !

!TPMCRepository methodsFor: 'required' stamp: 'CdG 2/28/2005 00:42'!
writeStreamForFileNamed: aString replace: ignoreBoolean do: aBlock
	"nothing needs to be done - MCCacheRepository is written to in any
	case and that is sufficient"! !

!MCCacheRepository methodsFor: '*tric-p2p-mc-overrides' stamp: 'CdG 3/4/2005 12:02'!
basicStoreVersion: aVersion 
	(self allFileNames includes: aVersion fileName) 
		ifFalse: [super basicStoreVersion: aVersion].
	TPMCService p2pAnnounce: aVersion fileName! !

!MCCacheRepository methodsFor: '*tric-p2p-mc-overrides' stamp: 'CdG 3/3/2005 21:00'!
rescan
	self newFileNames do:
		[:ea |
		TPMCRepository p2pAnnounce: ea.
		self versionReaderForFileNamed: ea do:
			[:reader |
			(self cacheForPackage: reader package)
				recordVersionInfo: reader info
				forFileNamed: ea.
			self seenFileNames add: ea]]
		displayingProgress: 'Scanning cache...'! !

Object subclass: #TPCChatPacket
	instanceVariableNames: 'text user endPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tric-P2P-Chat'!

!TPCChatPacket class methodsFor: 'instance creation' stamp: 'CdG 2/23/2005 22:35'!
fromByteArray: aByteArray
	| strm |
	strm _ ReferenceStream on: aByteArray readStream.
	^strm next

"
self fromByteArray: (self new text: 'foo'; user: 'bar'; endPoint: 123) asByteArray
"! !

!TPCChatPacket class methodsFor: 'instance creation' stamp: 'CdG 2/23/2005 22:31'!
text: aText fromUser: aString onEndPoint: aSmallInteger
	^self new
		text: aText;
		user: aString;
		endPoint: aSmallInteger! !

!TPCChatPacket methodsFor: 'converting' stamp: 'CdG 2/23/2005 22:34'!
asByteArray
	"I'm too lazy to go the manual route - fix this"
	| strm |
	strm _ ReferenceStream on: (ByteArray new: 1000) writeStream.
	strm nextPut: self.
	^strm contents

"
(self new text: 'foo'; user: 'bar'; endPoint: 123) asByteArray

"! !

!TPCChatPacket methodsFor: 'accessing' stamp: 'CdG 2/23/2005 22:31'!
endPoint
	^endPoint! !

!TPCChatPacket methodsFor: 'accessing' stamp: 'CdG 2/23/2005 22:31'!
endPoint: anObject
	endPoint := anObject! !

!TPCChatPacket methodsFor: 'accessing' stamp: 'CdG 2/23/2005 22:32'!
text
	^text! !

!TPCChatPacket methodsFor: 'accessing' stamp: 'CdG 2/23/2005 22:32'!
text: anObject
	text := anObject! !

!TPCChatPacket methodsFor: 'accessing' stamp: 'CdG 2/23/2005 22:31'!
user
	^user! !

!TPCChatPacket methodsFor: 'accessing' stamp: 'CdG 2/23/2005 22:31'!
user: anObject
	user := anObject! !
